EPOLL_CREATE(2)

NAME
epoll_create, epoll_create1 - open an epoll file descriptor

SYNOPSIS
#include <sys/epoll.h>

int epoll_create(int size);
int epoll_create1(int flags);

DESCRIPTION
epoll_create() opens an epoll file descriptor by requesting the kernel to allocate an event backing store dimensioned for size descriptors. The size is not the maximum size of the backing store but just a hint to the kernel about how to dimension internal structures. (Nowadays, size is ignored; see NOTES below.) The returned file descriptor is used for all the subsequent calls to the epoll interface. The file descriptor returned by epoll_create() must be closed by using close(2). If flags is 0, then, other than the fact that the obsolete flags argument is dropped, epoll_create1() is the same as epoll_create(). The following value can be included in flags to obtain different behavior:

EPOLL_CLOEXEC
    Set the close-on-exec (FD_CLOEXEC) flag on the new file descriptor. See the description of the O_CLOEXEC flag in open(2) for reasons why this may be useful.

RETURN VALUE
On success, these system calls return a non-negative file descriptor. On error, -1 is returned, and errno is set to indicate the error.

ERRORS

EINVAL
    size is not positive.

EINVAL
    (epoll_create1()) Invalid value specified in flags.

ENFILE
    The system limit on the total number of open files has been reached.

ENOMEM
    There was insufficient memory to create the kernel object.

CONFORMING TO
epoll_create() is Linux-specific, and was introduced in kernel 2.5.44.

NOTES
Since Linux 2.6.8, the size argument is unused. (The kernel dynamically sizes the required data structures without needing this initial hint.)

SEE ALSO
close(2), epoll_ctl(2), epoll_wait(2), epoll(7)

COLOPHON
This page is part of release 3.14 of the Linux man-pages project. A description of the project, and information about reporting bugs, can be found at http://www.kernel.org/doc/man-pages/.